#include <stdlib.h>
#include "common.h"

#include "common.c"

void fl_mgr_monitor(int timer)
{
	int i;

	for (i = timer;i > 0;i--) {
		printf("before %d sec..\n",i);
		system("cat /proc/net/ip6_flowlabel | grep \"^[0123456789]\"");
		sleep(1);
	}
}

int main(int ac,char **av)
{
    __u32 flowlabel = 0;
    int rsock, ssock, len, err_num, acpt;
    socklen_t sin6_len = 0;
    uint16_t d_port = 0;
    uint16_t port = 0;
    struct in6_addr addr;
    struct sockaddr_in6 sin6, d_sin6;
    char *target, v6addr[128];

    rsock = ssock = len = err_num = acpt = 0;
    if (ac != 4) {
	printf("usage: %s <flowlabel> <bind_host> <wait_port>\n",av[0]);
	return 0;
    }

    sscanf(av[1],"%x",&flowlabel);
    if (flowlabel == 0) {
	printf("flowlabel is null.\n");
	return -1;
    }
    target = av[2];
    sscanf(av[3],"%d",&acpt);
    if (acpt == 0) {
	printf("wait_port is null.\n");
	return -2;
    } else {
	port = (uint16_t)acpt;
	acpt = 0;
    }

    if (getip6name(&addr, target, "bind_addr") < 0) return -3;

    sin6_len = sizeof(sin6);
    memset(&sin6, 0, sin6_len);
    memset(&d_sin6, 0, sin6_len);
    sin6.sin6_family = AF_INET6;
    memcpy(&sin6.sin6_addr, &addr, 16);

    rsock = socket(PF_INET6, SOCK_DGRAM, IPPROTO_UDP);
    if (rsock < 0) {
	printf("cannot open INET6 socket.\n");
	return -4;
    }
    if (set_rxflow(rsock) < 0) {
	printf("can't get flowlabel\n");
    }
    sin6.sin6_port = htons(port);
    if (bind(rsock, (struct sockaddr*)&sin6, sin6_len) == -1) {
	perror("bind");
	err_num = -10;
	goto err;
    }
    printf("binding...\n");
    memset(v6addr, 0, 128);
#if 1
    len = recvlabel(rsock,v6addr,128,0,(struct sockaddr *)&d_sin6,&sin6_len);
#else
    len = recvfrom(rsock,v6addr,128,0,(struct sockaddr *)&d_sin6,&sin6_len);
/* cannot use against UDP sock
    if (getlabel(rsock, &d_sin6, &sin6_len) < 0) {
	perror("getlabel");
	return -21;
    }
*/
#endif
    if (len < 0) {
	perror("recvlabel");
	err_num = -12;
	goto err;
    }
    printf("dst_host flow has 0x%x.\n",ntohl(d_sin6.sin6_flowinfo));
    printf("dst_port: %s\n", v6addr);
    sscanf(v6addr,"%d",&acpt);
    if (acpt == 0) {
	printf("dst_port is null.\n");
	err_num = -2;
	goto err;
    } else {
	d_port = (uint16_t)acpt;
	acpt = 0;
    }
    
/* cannot use against UDP sock
    if (getpeername(rsock, (struct sockaddr *)&sin6, &sin6_len) < 0) {
	perror("getpeername");
	err_num = -20;
	goto err;
    }
*/
    memset(v6addr, 0, 128);
    if (inet_ntop(AF_INET6, &d_sin6.sin6_addr, v6addr, 128) == NULL) {
	perror("inet_ntop");
	memcpy(v6addr, target, (strlen(target) < 127 ? strlen(target) : 127));
    }
    printf("dst_addr = %s\n",v6addr);

    system("cat /proc/net/ip6_flowlabel");
    len = 0;
    memset(v6addr, 0, 128);
    sprintf(v6addr, "flowlabel = 0x%x", flowlabel);

    ssock = socket(PF_INET6, SOCK_DGRAM, IPPROTO_UDP);
    d_sin6.sin6_port = htons(d_port);
    if (set_flowlabel(ssock, &d_sin6, flowlabel) < 0) {
	printf("cannot use flowlabel.\n");
	err_num = -5;
	goto err;
    }
	printf("setflowlabe..\n");
	fl_mgr_monitor(10);
//    release_flowlabel(ssock, &d_sin6, flowlabel);
    len = sendto(ssock,v6addr,strlen(v6addr),0,(struct sockaddr *)&d_sin6,sin6_len);
    if (len < 0) {
	perror("send");
	err_num = -7;
	goto err;
    }
	printf("sendto..\n");
	fl_mgr_monitor(5);
    release_flowlabel(ssock, &d_sin6, flowlabel);
	printf("released..\n");
	fl_mgr_monitor(10);

 err:
    close(rsock);
    close(ssock);
    return err_num;
}
